/****************************************************************************
 AIAccount.h
 
 Copyright (c) Microsoft Corporation
 
 Defines a mail account
 
 *****************************************************************************/

#import <Foundation/Foundation.h>
#import "AIContact.h"
#import "AIApiErrorCode.h"

/**
 * This protocol defines the information about the current user account
 */
@protocol AIAccount <NSObject>

/**
 * The user who owns the account
 *
 * @return The user who owns the account
 */
- (id<AIContact> _Nonnull)accountOwner;

/**
 * Checks if the account is an Exchange account or not
 *
 * @return YES if the account is an Exchange account, NO otherwise
 */
- (BOOL)isExchangeAccount;

@end

