/****************************************************************************
 AICommandGroup.h
 
 Copyright (c) Microsoft Corporation
 
 An objective-c representation of an app command group
 
 *****************************************************************************/

#import "AIGraphicalElement.h"
#import "AICommandButton.h"

@interface AICommandGroup : AIGraphicalElement
{
	NSMutableArray<AICommandButton *> * _Nullable _buttons;
}

/**
 *  The array of buttons inside this group
 *
 *  @return The buttons inside this group
 */
- (NSArray<AICommandButton *> * _Nonnull)buttons;

/**
 *  Adds a command button to this group
 *
 *  @param button The button to add to this group
 */
- (void)addCommandButton:(AICommandButton * _Nullable)button;

@end
