/****************************************************************************
 AICommandTab.h
 
 Copyright (c) Microsoft Corporation
 
 An Objective-C representation of a Ribbon tab
 
 *****************************************************************************/

#import "AIGraphicalElement.h"
#import "AICommandGroup.h"

@interface AICommandTab : AIGraphicalElement
{
	NSMutableArray<AICommandGroup*> * _Nullable _groups;
}

/**
 *  The groups inside this tab
 *
 *  @return An array of groups inside this tab
 */
- (NSArray<AICommandGroup *> * _Nonnull)groups;

/**
 *  Add a group to this tab
 *
 *  @param group The group to add to this tab
 */
- (void)addCommandGroup:(AICommandGroup * _Nullable)group;

@end
