/****************************************************************************
 AIContact.h
 
 Copyright (c) Microsoft Corporation
 
 Defines the interface for a contact
 
 *****************************************************************************/

#import <Foundation/Foundation.h>

/**
 * All information about a contact/user that may be required by the Addin 
 * framework.
 */
@protocol AIContact <NSObject>

/**
 * The name of the contact
 *
 * @return The name of the contact
 */
- (NSString * _Nullable)name;

/**
 * The contact email address
 *
 * @return The contact email address
 */
- (NSString * _Nonnull)email;

@end

