/****************************************************************************
 AIGraphicalElement.h
 
 Copyright (c) Microsoft Corporation
 
 A base class for the Objective-C representation of app commands
 
 *****************************************************************************/

#import <Foundation/Foundation.h>

@interface AIGraphicalElement : NSObject

/**
 *  The identifier of this particular element
 */
@property (copy) NSString * _Nullable identifier;

/**
 *  The owner of this element
 */
@property (copy) NSString * _Nullable ownerId;

/**
 *  The label for this element when displayed graphically
 */
@property (copy) NSString * _Nullable label;

/**
 *  Creates a new graphical element with the supplied parameters
 *
 *  @param identifier The identifier of this element
 *  @param ownerId    The owner identifier of this element
 *  @param label      The label of this element
 *
 *  @return A new graphical element
 */
- (instancetype _Nonnull)initWithIdentifier:(NSString * _Nullable)identifier
									ownerId:(NSString * _Nullable)ownerId
									  label:(NSString * _Nullable)label;

@end
