/****************************************************************************
 AIMeetingRequest.h
 
 Copyright (c) Microsoft Corporation
 
 Defines the interface for a meeting request
 
 *****************************************************************************/

#import <Foundation/Foundation.h>

@protocol AIMeetingRequest <NSObject>

/**
 *  The start time of the meeting request
 *
 *  @return The start time of the meeting request
 */
- (NSDate * _Nullable)startTime;

/**
 *  The end time of the meeting request
 *
 *  @return The end time of the meeting request
 */
- (NSDate * _Nullable)endTime;

/**
 *  The location of the meeting
 *
 *  @return The location of the meeting
 */
- (NSString * _Nullable)location;

/**
 *  The organizer of the meeting
 *
 *  @return The organizer of the meeting
 */
- (id<AIContact> _Nullable)organizer;

@end

