/****************************************************************************
 AIOutlookPermissionLevel.h
 
 Copyright (c) Microsoft Corporation
 
 The various levels of permission which Outlook add-ins may have. Each has 
 restrictions on which APIs may be called.
 
 *****************************************************************************/

#import <Foundation/Foundation.h>

/**
 *  The various Outlook supported permission levels (matches 
 *  OutlookPermissionLevels)
 */
typedef NS_ENUM(NSInteger, AIOutlookPermissionLevel) {
	AIOutlookPermissionLevel_Restricted = 1,
	AIOutlookPermissionLevel_ReadItem = 2,
	AIOutlookPermissionLevel_ReadWriteItem = 4,
	AIOutlookPermissionLevel_ReadWriteMailbox = 3
};
