/****************************************************************************
 AISandboxErrorCode.h
 
 Copyright (c) Microsoft Corporation
 
 Enum for sandbox error codes for the AddinsFramework
 
 *****************************************************************************/

#import <Foundation/Foundation.h>

/**
 *  The error codes used by the sandbox within the addin framework
 */
typedef NS_ENUM(NSInteger, AISandboxErrorCode)
{
	/**
	 *  A network error of some kind occured
	 */
	AISandboxErrorCode_NetworkError,
	
	/**
	 *  Some HTTP error occured. See accompanying error code for HTTP status 
	 *  code.
	 */
	AISandboxErrorCode_HTTPError,
	
	/**
	 *  The certificate presented by the add-in was invalid
	 */
	AISandboxErrorCode_InvalidCertificate
	
};
