/****************************************************************************
 AIStore.h
 
 Copyright (c) Microsoft Corporation
 
 An enum for the various possible providers
 
 *****************************************************************************/

#import <Foundation/Foundation.h>

/**
 * Store types
 */
typedef NS_ENUM(NSInteger, AIStore)
{
	//This should be kept in sync with the store types in enumwrappers.h
	AIStore_Unknown = -1, // store type read from file that we did not recognize (perhaps written by later version)
	AIStore_Omex = 0,
	AIStore_SPCatalog = 1,
	AIStore_SPApp = 2,
	AIStore_Exchange = 3,
	AIStore_Filesystem = 4,
	AIStore_Registry = 5,
	AIStore_Recommendation = 6, // This store type should not be changed unless sychronized with Javascript side.
	AIStore_Count = 7
};
