/****************************************************************************
 AITokenType.h
 
 Copyright (c) Microsoft Corporation
 
 The various token types which may be requested
 
 *****************************************************************************/

#import <Foundation/Foundation.h>

/**
 *  The various token types which may be requested
 */
typedef NS_ENUM(NSInteger, AITokenType) {
	/**
	 *  A unique identifier for a particular O365 account
	 */
	AITokenType_UserIdentity,
	/**
	 *  A token for getting files, etc from Exchange with a very short lifetime 
	 *  (currently 5 minutes)
	 */
	AITokenType_CallbackScoped
};
