/****************************************************************************
 AddinsFramework.h
 
 Copyright (c) Microsoft Corporation
 
 Umbrella header for the AddinsFramework
 
 *****************************************************************************/

#import <UIKit/UIKit.h>

//! Project version number for AddinsFramework.
FOUNDATION_EXPORT double AddinsFrameworkVersionNumber;

//! Project version string for AddinsFramework.
FOUNDATION_EXPORT const unsigned char AddinsFrameworkVersionString[];


#import "AIAddinManager.h"
#import "AIAddinStateManager.h"
#import "AIIconHandler.h"

// API Helpers
#import "AINotification.h"

// Enums
#import "AIApiErrorCode.h"
#import "AIErrorCode.h"
#import "AIMessageType.h"
#import "AINotificationType.h"
#import "AIOutlookPermissionLevel.h"
#import "AIRecipientType.h"
#import "AIResourceType.h"
#import "AIStore.h"
#import "AITokenType.h"

// Protocols
#import "AIApiHandler.h"
#import "AIAttachment.h"
#import "AIContact.h"
#import "AIMeetingRequest.h"
#import "AIMessage.h"
#import "AIProvider.h"
#import "AITaskpaneProvider.h"

// Other
#import "AICommandButton.h"
#import "AICommandGroup.h"
#import "AICommandTab.h"
#import "AICommandApp.h"
